# Avorion Script API Documentation

Home Functions Search
Search:

ReadOnlyControlUnit ReadOnlyControlUnit
Properties
autoPilotEnabled
desiredVelocity
entity
entityId
hasPilot
isBoosting
isDrifting
isStrafing
isTurning
numFreeSeats
numOccupiedSeats
turningSpeedFactor
Member Functions
getActiveWeapons
getAimedPositionBySeat
getAimedPositionByWeaponGroup
getAimedPositions
getAllControlActions
getControlActions
getControlActionsByWeaponGroup
getFlownToLocation
getSeatByWeaponGroup
getSeats
getSelectedObject
getSelectedObjectId
getSelectedObjectIds
isFiring
isFiringTorpedoes
isPlayerAPilot
mayControlSquad
mayControlWeaponGroup
maySteer

# ReadOnlyControlUnit

function ReadOnlyControlUnit(var id)

Parameters

id The id of the entity, must be an index of an existing entity or nil for the entity in the current script context

Returns

A new instance of ReadOnlyControlUnit

property bool autoPilotEnabled | [read-only]

property float desiredVelocity | [read-only]

The current velocity the ship is trying to fly from 0 to 1, where 0 means standstill and 1 means the maximum speed the ship can fly without boosting.

property Entity entity | [read-only]

property uuid entityId | [read-only]

property bool hasPilot | [read-only]

property bool isBoosting | [read-only]

property bool isDrifting | [read-only]

property bool isStrafing | [read-only]

property bool isTurning | [read-only]

property int numFreeSeats | [read-only]

property int numOccupiedSeats | [read-only]

property vec3 turningSpeedFactor | [read-only]

A vec3 containing the turning speed multipliers for axis x, y, z. The turning speed factor is a multiplier for the turning speed of a ship, and is set in flyToLocation(), to smoothen turning once the ship looks towards its target (to avoid jittering).

function bitset<10> getActiveWeapons()

Returns a list of bools representing the currently active weapon groups.

function vec3 getAimedPositionBySeat(int seatIndex)

Returns the aimed position of a given seat.

Parameters

seatIndex The index of the seat

function vec3 getAimedPositionByWeaponGroup(int groupIndex)

Returns the aimed position of the seat that controls the given weapon group.

Parameters

groupIndex The weapon group of the seat

function vec3... getAimedPositions()

Returns a list of aimed positions of all seats

function int... getAllControlActions()

Returns a list of bitsets (represented as ints) of control actions of all seats.

function int getControlActions(int seatIndex)

Returns the bitset of control actions of a given seat.

Parameters

seatIndex The index of the seat

function int getControlActionsByWeaponGroup(int groupIndex)

Returns the bitset of control actions of the seat that controls the given weapon group.

Parameters

groupIndex The weapon group of the seat

function vec3 getFlownToLocation()

Returns the currently flown to location, which is set by calls to flyToLocation. Note: When the AI flies towards a location, it also sets this.

function int getSeatByWeaponGroup(int groupIndex)

Returns the seat that controls a particular weapon group.

Parameters

groupIndex The weapon group of the seat

function ControlUnitSeat... getSeats()

Returns a list of seats of the control unit.

function Entity getSelectedObject(int seatIndex)

Returns the selected object of a given seat.

Parameters

seatIndex The index of the seat

function uuid getSelectedObjectId(int seatIndex)

Returns the id of the selected object of a given seat.

Parameters

seatIndex The index of the seat

function uuid... getSelectedObjectIds()

Returns a list of selected target ids of all seats

function bool isFiring(int seat)

Checks if the given seat is currently pushing "Fire" (see ControlActionBit.Fire1)

function bool isFiringTorpedoes(int seat)

Checks if the given seat is currently pushing "Fire Torpedoes" (see ControlActionBit.Fire2)

function bool isPlayerAPilot(int playerIndex)

Checks if the given player is setting in any seat of the control unit.

Parameters

playerIndex The index of the player

function bool mayControlSquad(int playerIndex, int squadIndex)

Checks if the given player has the right to control the given fighter squad.

Parameters

playerIndex The index of the player
squadIndex The index of the squad

function bool mayControlWeaponGroup(int playerIndex, int groupIndex)

Checks if the given player has the right to control the given weapon group.

Parameters

playerIndex The index of the player
groupIndex The index of the weapon group

function bool maySteer(int playerIndex)

Checks if the given player has the right to pilot (steer) the ship. The player must be sitting in the pilot seat.

Parameters

playerIndex The index of the player
Overview
Home Functions Search
Search:
Callbacks
Callbacks Alliance [Client] Callbacks Alliance [Server] Callbacks Alliance [Server] Callbacks Entity Callbacks Galaxy Callbacks Player Callbacks Player [Client] Callbacks Sector Callbacks Server Callbacks
Predefined Functions & Example Scripts
Command Entity FactionDatabase PlanGenerator Player Sector Server UsableInventoryItem
Common Components
Boarding BspTree CargoBay CargoLoot ControlUnit CrewComponent DeletionTimer DirectFlightPhysics DockingClamps DockingParent DockingPositions Durability EnergySystem Engine FighterAI Hangar HyperspaceEngine InteractionText InventoryItemLoot Owner Physics Plan ReadOnlyBoarding ReadOnlyBspTree ReadOnlyCargoBay ReadOnlyControlUnit ReadOnlyCrew ReadOnlyDeletionTimer ReadOnlyEnergySystem ReadOnlyEngine ReadOnlyFighterAI ReadOnlyHangar ReadOnlyHyperspaceEngine ReadOnlyInteractionText ReadOnlyOwner ReadOnlyPhysics ReadOnlyPlan ReadOnlyShipAI ReadOnlyShipSystem ReadOnlyTorpedoAI [Server] [Client] [Server] [Client] ReadOnlyTorpedoAI [Server] [Client] [Server] [Client] ReadOnlyTorpedoLauncher ReadOnlyTurretBases ReadOnlyVelocity ReadOnlyWeapons ReadOnlyWormHole Shield ShipAI ShipSystem StructuralIntegrity SystemUpgradeLoot Thrusters Torpedo TorpedoAI TorpedoLauncher Turret TurretAI TurretBases Velocity Weapons WormHole
Common Objects
AllianceMember AllianceRank BlockPlan BlockPlanBlock BlockStatistics Box Captain Color ControlUnitSeat CraftDesign CraftStatsOverview Crew CrewMan CrewProfession DebugInfo dvec2 dvec3 dvec4 Entity EntityDescriptor FighterTemplate Format GameSettings Group HighResolutionTimer Inventory InventoryTurret ivec2 ivec3 ivec4 Language Mail Material Matrix ModManager NamedFormat PlanBspTree PlanetSpecifics PlanGenerationStage PlanPart PlanStyle PlayerId PluralForm Profiler QuadTree Random Rarity Ray ReadOnlyEntity Rect Relation Scenario SectorView Seed Sphere Squad SystemUpgradeTemplate Timer Tooltip TooltipLine TorpedoShaft TorpedoTemplate TradingGood TurretDesign TurretDesignPart TurretTemplate UsableInventoryItem Uuid VanillaInventoryItem vec2 vec3 vec4 Version Weapon
Client Components
EntityIcon EntityTooltip PlanMesh ReadOnlyIcon ReadOnlyPlanMesh ReadOnlyScriptUI ReadOnlyTooltip ScriptUI
Client Objects
Achievements Alliance [Client] CameraKeyFrame CaptainSelectionItem Client ClientSettings ColorSelectionItem CraftDesignSelectionItem Faction [Client] Galaxy [Client] GalaxyMap GameInput GlowFX IconSelectionItem InputWindow InventoryReferenceSelectionItem InventorySelectionItem Keyboard LaserFX Mouse Music PixelIconSelectionItem Planet Player [Client] PlayerWindow RefractionFX Sector [Client] SelectionItem ShipDatabaseEntry [Client] SoundSource StrategyState TargetIndicator TooltipRenderer TurretDesignSelectionItem
Client UI Objects
AllianceEmblem AllianceTab ArrowLine Button [Client] [Client] Button [Client] [Client] CaptainIcon CaptainProfile CheckBox ComboBox ContextMenu CraftPortrait CrewBar Frame Hud InventorySelection Label Line ListBox ListBoxEx MapArrowLine MapIcon MultiLineTextBox NumbersBar Picture PlanDisplayer ProgressBar SavedDesignsSelection ScrollFrame Selection ShipWindow Slider StatisticsBar Tab TabbedWindow TextBox TextField TooltipDisplayer Tree UIArbitraryHorizontalSplitter UIArbitraryVerticalSplitter UIContainer UIElement UIGridSplitter UIHorizontalLister UIHorizontalMultiSplitter UIHorizontalSplitter UIOrganizer UIRect UIRenderer UIVerticalLister UIVerticalMultiSplitter UIVerticalSplitter ValueComboBox Window
Server Components
EntityTransferrer FighterController Loot ReadOnlyEntityTransferrer ReadOnlyFighterController ReadOnlyLoot ReadOnlyTurretController ReadOnlyWreckageCreator TurretController WreckageCreator
Server Objects
Alliance [Server] Faction [Server] Galaxy [Server] Player [Server] ReadOnlySector Sector [Server] Server ShipDatabaseEntry [Server]
Enums
AIState AlliancePrivilege BeamShape BlockShading BlockStructure BlockType BlockType2 BoxType BuildError CaptainGenderId ChatChannel ChatMessageType ComponentType ControlAction ControlActionBit ControlStyle CoolingType CraftStatsOverviewStat CrewProfessionType CrewRank DamageSource DamageType DeletionType Difficulty EntityArrivalType EntityType FighterOrders FighterStartError FighterType FontType ImpactParticles InventoryItemType JumpError KeyboardKey ListBoxEntryType MalusReason MaterialType MoonType MouseButton PlanetType PlanTypeFilter PlayerStateType ProjectileShape RarityType RelationStatus SavedDesignType ScenarioType SectorChangeType ShipAvailability SoundType StatsBonuses TargetIndicatorVisuals TransformationFeature TurretAutoFireMode TurretSlotType WeaponAppearance WeaponCategory

This is the official documentation for the scripting API of Avorion. This documentation is automatically generated and not necessarily complete. Depending on the context in which functions exist, some documentation such as descriptions, return values or variable names or types may be missing.

Work in Progress. Documentation of Avorion Version: 2.5.8 a0d3f0b5b065